package client;

import javax.xml.bind.*;
import javax.xml.bind.annotation.*;
import java.io.*;

@XmlRootElement
@XmlType(propOrder={"person","numero","rue","ville"})
public class Client {
    // Par défaut JAXB ne sérialise que les champs/accesseurs publics
    int num;
    String nom;
    Adresse adr = new Adresse();

    @XmlElement(name="personne")
    public Person getPerson() {
        return new Person(num,nom);
    }
    public void setPerson(Person p) {
        num = p.num;
        nom = p.nom;
    }

    public int getNumero() {
        return adr.num;
    }
    public void setNumero(int num) {
        adr.num = num;
    }

    public String getRue() {
        return adr.rue;
    }
    public void setRue(String rue) {
        adr.rue = rue;
    }

    public String getVille() {
        return adr.ville;
    }
    public void setVille(String ville) {
        adr.ville = ville;
    }

    // test 
    public static void main(String[] args) throws Exception {
        Client c = new Client();
        c.num = 123456;
        c.nom = "Toto";
        c.adr.num = 8;
        c.adr.rue = "N.Bohr";
        c.adr.ville = "Villeurbanne";
        JAXBContext ct = JAXBContext.newInstance(Client.class);
        Marshaller m = ct.createMarshaller();
        m.setProperty("jaxb.formatted.output",true);
        m.marshal(c, new File("client.xml"));
    }
}

class Adresse {
    int num;
    String rue;
    String ville;
}

class Person {
    @XmlAttribute
    public int num;
    @XmlValue
    String nom;

    public Person(int num, String nom) {
        this.num = num;
        this.nom = nom;
    }
}
